-- main.lua
-- Used for a plugin, "Ryusei_fittings", to add wing leveler control when joystick
-- is in neutral positopn.
-- This Plugin shall be stored in plugins folder of the airplane.

setAircraftPanelRendering(false)
set3DRendering(false)
setInteractivity(false)

addSearchResourcesPath ( moduleDirectory .. "/configuration/" )
local rollHold = findCommand ( "sim/autopilot/wing_leveler" )
local autoPower = globalPropertyi("sim/cockpit/autopilot/autopilot_mode")
-- The autopilot master mode (off=0, flight director=1, on=2)
local roll = globalPropertyf("sim/flightmodel2/controls/roll_ratio") 
--  -1.0 is full left, and 1.0 is full right, W
local rollStatus = globalPropertyi("sim/cockpit2/autopilot/roll_status")
--     Autopilot Roll-Hold Status. 0=off,2=captured    RO
local rollDeg = globalPropertyf("sim/cockpit2/autopilot/set_roll_deg")
local altFt = globalPropertyf("sim/cockpit2/gauges/indicators/altitude_ft_pilot")

cycle2 = 0
cycle3 = 0
-- set(autoPower, 0)
roll_ratio = { }
for i = 1, 10 do -- 操縦桿ピッチ履歴を全て0(中立)に設定
	roll_ratio [i] = 0
end

-- Control functions  ------------------------------------------
function update()
	-- Mean roll value of latest 10 samples --------------------
	mean_roll = get ( roll )                          -- 最初の操縦桿ロール値取得
	for i = 2, 10 do
		mean_roll = mean_roll + roll_ratio [ i ]
		roll_ratio [ i - 1 ] = roll_ratio [ i ]
	end
	roll_ratio [ 10 ] = get ( roll )
	mean_roll = mean_roll / 10                        -- 操縦桿ロールの10 回平均取得
	
	-- Set wing leveler by height and stick operation  ---------------- 
	if get(altFt)>100 then                            -- 高度100ft以下で
		if math.abs(mean_roll)<0.1 then               -- 操縦桿左右中立の時Wing leveler起動
			if cycle2 == 0 then
-- 				set(autoPower, 2)
				sasl.commandOnce( rollHold )
				set(rollDeg, 0.0)
				print("rollStatus:", get(rollStatus))
				cycle2 = 1
				cycle3 = 0
			end
		elseif math.abs(mean_roll)>0.1 then           -- 操縦桿左右中立以外の時Wing leveler停止
			if cycle3 == 0 then
				sasl.commandOnce( rollHold )
-- 				set(autoPower, 0)
				print("rollStatus:", get(rollStatus))
				cycle2 = 0
				cycle3 = 1
			end
		end
	end
end